/*
 */

#include "hbytes.h"

void scriptinv_init(ScriptToInvoke *si) {
  si->obj= 0;
}

void scriptinv_cancel(ScriptToInvoke *si) {
  if (si->obj) {
    Tcl_DecrRefCount(si->obj);
    si->obj= 0;
  }
}

int scriptinv_set(ScriptToInvoke *si, Tcl_Interp *ip, Tcl_Obj *newscript) {
  int rc;
  
  scriptinv_cancel(si);

  rc= Tcl_ListObjLength(ip, newscript, &si->llength);
  if (rc) return rc;

  Tcl_IncrRefCount(newscript);
  si->obj= newscript;
  si->ip= ip;
  return 0;
}  
  
void scriptinv_invoke(ScriptToInvoke *si, int argc, Tcl_Obj **argv) {
  Tcl_Obj *invoke=0;
  int i, rc;

  assert(si->obj);

  for (i=0; i<argc; i++) Tcl_IncrRefCount(argv[i]);
  invoke= Tcl_DuplicateObj(si->obj);
  Tcl_IncrRefCount(invoke);

  rc= Tcl_ListObjReplace(si->ip,invoke,si->llength,0,argc,argv);
  for (i=0; i<argc; i++) { Tcl_DecrRefCount(argv[i]); argv[i]= 0; }
  if (rc) goto x_rc;

  rc= Tcl_EvalObjEx(si->ip,invoke,TCL_EVAL_GLOBAL|TCL_EVAL_DIRECT);
  if (rc) goto x_rc;

  rc= 0;
  
x_rc:
  if (invoke) Tcl_DecrRefCount(invoke);
  if (rc) Tcl_BackgroundError(si->ip);
}
